;
; ********************************************
; * [Projekttitel hier einfuegen]            *
; * [Mehr Infos zur Softwareversion hier]    *
; * (C)20xx by [Copyrightinformation hier]   *
; ********************************************
;
; Include-Datei fuer den betreffenden AVR-Typ
.NOLIST
.INCLUDE "m8def.inc" ; Headerdatei fuer ATMEGA8
.LIST
;
; ============================================
;   H A R D W A R E I N F O R M A T I O N E N 
; ============================================
;
; [Beschreibe die gesamte Hardware hier]
;
; ============================================
;      P O R T S   U N D   P I N S 
; ============================================
;
; [Namen fuer Hardware-Ports und Pins hier]
; Format: .EQU pControlportout = PORTA
;         .EQU pControlportin = PINA
;         .EQU pbLedOutputPin = PORTA2
;
; ================================================
; K O N S T A N T E N   Z U M  E I N S T E L L E N
; ================================================
;
; [Alle Konstanten zum Voreinstellen, deren Werte
;  vom Benutzer sinnvoll verstellt werden koennen]
; Format: .EQU vKonst = $ABCD
;
; =======================================================
;  F E S T E + A B G E L E I T E T E  K O N S T A N T E N 
; =======================================================
;
; [Alle Konstanten hier definieren, die nicht sinnvoll
;  verstellt werden koennen oder die sich aus anderen
;   Konstanten berechnen]
; Format: .EQU cKonst = $ABCD
.equ XTAL = 3686400
;
; ============================================
;   R E G I S T E R D E F I N I T I O N E N
; ============================================
;
; [Alle Registernamen hier, plus Informationen
;  ueber die Verwendung von Registern, auch von nicht
;  mit Namen belegten]
; R0 verwendet fuer LPM
; R1..R5 verwendet fuer Berechnungen
; Frei: R6..R15
; Format: .DEF rmp = R16
;
.DEF State = r24
.DEF Secs = r28
.DEF Mins = r27
; ============================================
;       S R A M   D E F I N I T I O N E N
; ============================================
;
.DSEG
.ORG  0X0060
; Format: Label: .BYTE N ; Reserviere N Bytes fuer ...
;
; ==============================================
;   R E S E T   U N D   I N T   V E K T O R E N
; ==============================================
;
.CSEG
.ORG $0000
	rjmp Main ; Reset-Vektor 1
	reti ; Int Vektor 2
	reti ; Int Vektor 3
	reti ; Int Vektor 4
	reti ; Int Vektor 5
	reti ; Int Vektor 6
	rjmp onCompA ; Int Vektor 7
	reti ; Int Vektor 8
	reti ; Int Vektor 9
	reti ; Int Vektor 10
	reti ; Int Vektor 11
	reti ; Int Vektor 12
	reti ; Int Vektor 13
	reti ; Int Vektor 14
	reti ; Int Vektor 15
	reti ; Int Vektor 16
	reti ; Int Vektor 17
	reti ; Int Vektor 18
	reti ; Int Vektor 19
;
; ==========================================
;    I N T E R R U P T   S E R V I C E
; ==========================================
;
; [Hier alle Interrupt Service Routinen]
;
; ============================================
;    H A U P T P R O G R A M M    I N I T
; ============================================
;
Main:
; Initiire Stapel
	ldi r16, HIGH(RAMEND) ; Initiiere MSB Stapel
	out SPH,r16
	ldi r16, LOW(RAMEND) ; Initiiere LSB Stapel
	out SPL,r16
	ldi State, 0x00
	ldi r24, 0
	ldi r16, 0
	out	DDRB, r16
	ldi r16, 0xFF
	out	DDRC, r16
	out DDRD, r16
	out PORTB, r16
	ldi r28, 0
	ori r28, (1<<OCIE1A)
	out TIMSK, r28
	ldi r28, 0x38
	out OCR1AH, r28
	ldi r28, 0x40
	out OCR1AL, r28
	ldi r28, 0
	out TCCR1A, r28
	ori r28, (1<<WGM12)
	out TCCR1B , r28
	ldi r26 ,0
	sei
;
; ============================================
;     P R O G R A M M - S C H L E I F E
; ============================================
;
Loop:
	nop ; Dummy fuer Aufwecken

Test0:
	cpi	State, 0
	brne Test1
	rcall State0
	rcall readBtn
	rjmp loop ; Zurueck nach Loop
Test1:
	cpi	State, 1
	brne Test2
	rcall State1	
	rcall readBtn
	rjmp loop ; Zurueck nach Loop
Test2:
	cpi	State, 2
	brne Test3
	rcall State2	
	rcall readBtn
	rjmp loop ; Zurueck nach Loop
Test3:
	cpi	State, 3
	brne Test4
	rcall State3
	rcall readBtn
	rjmp loop ; Zurueck nach Loop
Test4:
	cpi	State, 4
	rcall State4
	rjmp loop ; Zurueck nach Loop






readBtn:
	push r16
	in r16, PINB
	andi r16, 0x01
	cpi	r16, 0b00000001
	breq retBtn
	rcall delay50us
	in r16, PINB
	andi r16, 0x01
	cpi	r16, 0b00000001
	brne retBtn
	rcall incState
retBtn:
	pop r16
	ret


onCompA:
	rcall incTime
	cpi r26, 0
	breq LedOn
	com r26
	cbi PORTD, 2
	reti
LedOn:
	com r26
	sbi PORTD, 2
_TimerRet:
	reti

incTime:
	subi	Secs, byte1(-1)	      ;     enc_delta++;
	cpi Secs, 60
	brne _retInc
	cpi Mins, 59
	breq _retInc
	inc Mins
	clr Secs
_retInc:
	ret


incState:
	inc State;
	ret



State0:
	out	PORTC, State
	ret
State1:
	out	PORTC, State
	push r28
	in r28, TCCR1B
	ori r28, (1<< CS12)
	out TCCR1B , r28
	pop r28
	rcall incState
	ret
State2:
	out	PORTC, State
	ret
State3:
	out	PORTC, State
	in r28, TCCR1B
	andi r28, 0b11111000
	out TCCR1B, r28
	rcall incState
	ret
State4:
	clr	State
	out	PORTC, State
	ret



delay50us:                              ; 50us Pause
           ldi  r25, ( XTAL * 50 / 3 ) / 1000000
delay50us_:
           dec  r25
           brne delay50us_
           ret                          ; wieder zurck




;
; Ende Quellcode


